﻿<?
// konfiguracja
$iloscCykliUczenia = 50;
$poczatkowyWspolczynnikUczenia = 1.0;
$zmianaWspolczynnikaUczeniaCoCykl = 0.995;
$iloscNeuronówNaWarstwachUkrytych = array(13);

$timeStart = microtime(true);
include('kategorie.php');
include('klasy/neuron.php');
include('klasy/warstwa.php');
include('klasy/siec.php');

$iloscNeuronówNaWarstwach = $iloscNeuronówNaWarstwachUkrytych;
$iloscNeuronówNaWarstwach[] = 7;

Siec::utworz($iloscNeuronówNaWarstwach, 19);
Siec::$N = $poczatkowyWspolczynnikUczenia;
// ladowanie danych treningowych
$data = unserialize(file_get_contents('data_serialized/segmentation.data'));
// uczenie za pomoca danych treningowych
for($i = 0; $i < $iloscCykliUczenia; $i++)
{
	foreach($data as $dataLinijka)
	{
		Siec::obliczWyjsciaWszystkichNeuronow($dataLinijka['wejscie']);
		Siec::uczNeurony($dataLinijka['wyjscie']);
	}
	Siec::$N *= $zmianaWspolczynnikaUczeniaCoCykl;
}
// generowanie statystyk dla zbioru testowego
$wyniki = array();
$wyniki['BRICKFACE'] = array(0,0,0,0,0,0,0);
$wyniki['SKY'] = array(0,0,0,0,0,0,0);
$wyniki['FOLIAGE'] = array(0,0,0,0,0,0,0);
$wyniki['CEMENT'] = array(0,0,0,0,0,0,0);
$wyniki['WINDOW'] = array(0,0,0,0,0,0,0);
$wyniki['PATH'] = array(0,0,0,0,0,0,0);
$wyniki['GRASS'] = array(0,0,0,0,0,0,0);
// ladowanie danych testowych
$data = unserialize(file_get_contents('data_serialized/segmentation.test'));
// obliczanie klasy dla danych testowych, zapisywanie do tablicy
foreach($data as $dataLinijka)
{
	Siec::obliczWyjsciaWszystkichNeuronow($dataLinijka['wejscie']);
	$wyniki[$dataLinijka['klasa']][Siec::pobierzWyliczonaKlase()]++;
}
// wyswietlanie informacji o sieci i statystyk testow
echo '<html><head><title>NAI</title><style>
table {
	border-width: 1px;
	border-spacing: 0px;
	border-style: dashed;
	border-color: gray;
	border-collapse: separate;
	background-color: white;
}
td {
	border-width: 1px;
	padding: 1px;
	border-style: dashed;
	border-color: gray;
	width:100px;
	height:30px;
	text-align:center;
}
tr:hover {background-color:#DDDDDD;}
.bad {background-color:#FF9999;}
.good {background-color:#99FF99;}</style></head><body><table><tr><td></td>';
foreach($wyniki as $klasa => $dane)
{
	echo '<td style="font-weight:bold">' . $klasa . '</td>';
}
echo '<td style="font-weight:bold">POPRAWNYCH</td></tr>';
$sumaPoprawnych = 0;
$sumaWszystkich = 0;
foreach($wyniki as $klasa => $dane)
{
	echo '<tr><td style="font-weight:bold">' . $klasa . '</td>';
	$poprawnych = 0;
	$wszystkich = 0;
	foreach($dane as $kolumna => $wynik)
	{
		if($kategorie_rev[$klasa] == $kolumna)
		{
			echo '<td class="good">' . $wynik . '</td>';
			$poprawnych += $wynik;
		}
		elseif($wynik > 0)
			echo '<td class="bad">' . $wynik . '</td>';
		else
			echo '<td>' . $wynik . '</td>';
		$wszystkich += $wynik;
	}
	$sumaPoprawnych += $poprawnych;
	$sumaWszystkich += $wszystkich;
	echo '<td>' . round(($poprawnych / $wszystkich) * 100, 2) . '%</td></tr>';
}
echo '<tr><td></td>';
foreach($wyniki as $dane)
{
	echo '<td></td>';
}
echo '<td><b>Średnia:</b> ' . round(($sumaPoprawnych / $sumaWszystkich) * 100, 2) . '%</td></tr></table>';
echo '<h3>Sieć</h3>Ilość cykli uczenia: <b>' . $iloscCykliUczenia . '</b><br />
Początkowy współczynnik uczenia: <b>' . $poczatkowyWspolczynnikUczenia . '</b><br />
Zmiana współczynnika co cykl: <b>-' . ((1 - $zmianaWspolczynnikaUczeniaCoCykl) * 100) . '%</b><br />
<table style="font-size:12px"><tr><td><b>' . count(Siec::$wejscia) . '</b></td>';
foreach(Siec::$warstwy as $warstwa)
{
	echo '<td><b>' . count($warstwa->neurony) . '</b></td>';
}
echo '<td><b>' . count($warstwa->neurony) . '</b></td></tr><tr><td>';
foreach($dataLinijka['wejscie'] as $i => $wejscie)
{
	echo 'x<sub>' . $i . '</sub><br />';
}
foreach(Siec::$warstwy as $warstwa)
{
	echo '<td>';
	foreach($warstwa->neurony as $i => $wejscie)
	{
		echo '<img src="neuron.png" alt="" /><br />';
	}
	echo '</td>';
}
echo '<td>';
foreach(Siec::$warstwy[count(Siec::$warstwy) -1]->neurony as $i => $wejscie)
{
	echo 'y<sub>' . $i . '</sub><br />';
}
echo '</td>';
echo '</td></tr></table>';
echo '<br />Czas wykonania skryptu: ' . round(microtime(true) - $timeStart, 2) . ' s';
echo '</body></html>';